<?php

namespace flipbox\hubspot\modules\http\services;

use flipbox\hubspot\authentication\AuthenticationStrategyInterface;
use Flipbox\Relay\HubSpot\Segment\TimelineEvents\Create;
use Psr\Http\Message\ResponseInterface;

class TimelineEvents extends AbstractResource
{
    /**
     * @param array $payload
     * @param AuthenticationStrategyInterface|null $authenticationStrategy
     * @return ResponseInterface
     */
    public function create(
        int $appId,
        array $payload,
        AuthenticationStrategyInterface $authenticationStrategy = null
    )
    {
        // Create runner segments
        $segments = new Create(
            [
                'appId'   => $appId,
                'payload' => $payload,
                'logger'  => $this->getLogger()
            ]
        );

        // Prepend authorization
        $this->prependAuthenticationMiddleware(
            $segments,
            $authenticationStrategy
        );

        return $segments->run();
    }
}
